#include <stdio.h>
#include <rpc/rpc.h>
#include "rusers.h"

main(argc, argv)
int argc;
char *argv[];
{
    CLIENT *cl;
    results *resultp;
    struct personinfo *currp;
    int filler;
    int i;
    int error = 0;

    if (argc < 2) {
       fprintf(stderr, "%s: usage: %s server [server...]\n",
               argv[0], argv[0]);
       exit(1);
    }

    for (i = 1; argv[i]; i++) {
       printf("---------- %s -------------\n", argv[i]);
       cl = clnt_create(argv[i], RUSERS_PROG, RUSERS_VERS,
                        "netpath");
       if (cl == NULL) {
            clnt_pcreateerror(argv[i]);
            error = 1;
            continue;
       }

       resultp = rusers_1(&filler, cl);
       if (resultp == NULL) {
            clnt_perror(cl, "rusers_1");
            error = 1;
            continue;
       }
  
       if (resultp->status != 0) {
            printf("ERROR!\n");
            switch (resultp->results_u.reason) {
               case NO_MEMORY:
                 printf("Server ran out of memory\n");
                 break;
               case CANT_GET_INFO:
                 printf("Server could not get info\n");
                 break;
            }
            error = 1;
            continue;
       }

       currp = resultp->results_u.personinfop;
    
       while (currp) {
           printf("%.20s\n", currp->login_name);
           currp = currp->nextp;
       }

       /*
        *  Free all data associated with this RPC
        */

       clnt_freeres(cl, xdr_results, resultp);
       clnt_destroy(cl);
    }
    
    exit(error);
}
