#include <stdio.h>
#include <tiuser.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#define SERV_PORT 5134
struct hostent *gethostbyname();

main(argc, argv)
int argc;
char **argv;
{
  int fd;                   /* fd into transport provider */
  int flags = 0;            /* used to receive info       */
  int i;                    /* indexes through user names */
  char buf[BUFSIZ];         /* holds message from server  */
  struct t_call *sndcall;   /* used to call server        */
  struct hostent *hp;       /* holds IP address of server */
  struct sockaddr_in myaddr; /* address that client uses  */
  struct sockaddr_in servaddr; /* the server's full addr  */
   /*
    *  Check for proper usage.
    */

   if (argc < 3) {
       fprintf(stderr,
               "Usage: %s server username [username...]\n",
               argv[0]);
       exit(1);
   }

   /*
    *  Create the transport endpoint.
    */

   if ((fd = t_open("/dev/tcp", O_RDWR, NULL)) < 0) {
       t_error("t_open failed!");
       exit(1);
   }

   /*
    *  Bind to an arbitrary return address.
    */

   if (t_bind(fd, NULL, NULL) < 0) {
       t_error("t_bind failed!");
       exit(1);
   }
   /*
    *  Get memory to hold call structure, copy in
    *  the server's address, and connect to the service.
    */
   if ((sndcall = (struct t_call *)t_alloc(fd, T_CALL,
                                     T_ADDR)) == NULL) {
       t_error("t_alloc failed!");
       exit(1);
   }

   sndcall->addr.len = sizeof(struct sockaddr_in);
   memset((void *)&servaddr, 0, sizeof(struct sockaddr_in));
   servaddr.sin_family = AF_INET;
   servaddr.sin_port = htons(SERV_PORT);

   hp = gethostbyname(argv[1]);
   if (hp == 0) {
       fprintf(stderr, "could not obtain address of %s\n",
               argv[1]);
       return (-1);
   }

   (void)memcpy((caddr_t)&servaddr.sin_addr,
               hp->h_addr_list[0], hp->h_length);

   (void)memcpy(sndcall->addr.buf, &servaddr,
                                          sizeof(servaddr));

   if (t_connect(fd, sndcall, NULL) < 0) {
       t_error("t_connect failed!");
       exit(1);
   }
   /*
    *  Send each user name, and read the response.
    *  The user names start at argv[2].
    */

   for (i = 2; i < argc; i++) {
      if (t_snd(fd, argv[i], strlen(argv[i])+1, 0) == -1) {
          t_error("t_snd failed!\n");
          exit(1);
      }
  
      /*
       *  We must pass the address of a flags integer to the
       *  t_rcv() routine, even though we do not use it in
       *  our application.
       */

      if (t_rcv(fd, buf, 1, &flags) == -1) {
          t_error("t_rcv failed!\n");
          exit(1);
      }
  
      if (buf[0] == 'y') {
          printf("%s is logged on server\n", argv[i]);
      } else {
          printf("%s is not logged on server\n", argv[i]);
      }
   }

   /*
    *  Perform the orderly release...
    */
   if (t_sndrel(fd) < 0) {
       t_error("t_sndrel failed!\n");
       exit(1);
   }
   /*
    *  Wait for server to respond with an orderly release.
    */

   (void) t_rcvrel(fd);

   exit(0);
}
