#include <stdio.h>
#include <fcntl.h>
#include <netdb.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/uio.h>
#include <netinet/in.h>
#include <sys/un.h>
#define SERV_ADDR  "/tmp/example1"

int
send_fds(file1, file2)
char *file1;
char *file2;
{
   struct msghdr msg;
   struct iovec iov[1];
   struct sockaddr_un servaddr;
   int fd_array[2];
   int sfd;
   int result;

   if ((fd_array[0] = open(file1, O_RDWR)) < 0) {
      return(-1);
   }

   if ((fd_array[1] = open(file2, O_RDWR)) < 0) {
      close(fd_array[0]);
      return(-1);
   }

   /*
    *  Get a socket into the AF_UNIX domain.
    */
   if ((sfd = socket(AF_UNIX, SOCK_STREAM, 0)) < 0) {
      close(fd_array[0]);
      close(fd_array[1]);
      return(-1);
   }

   /*
    *  Fill in the server's address and connect
    *  to the server.
    */

   bzero((char *)&servaddr, sizeof(servaddr));
   servaddr.sun_family = AF_UNIX;
   strcpy(servaddr.sun_path, SERV_ADDR);

   if (connect(sfd, (struct sockaddr *)&servaddr,
         strlen(SERV_ADDR) + sizeof(servaddr.sun_family)) < 0) {
      close(fd_array[0]);
      close(fd_array[1]);
      close(sfd);
      return(-1);
   }

   /*
    *  We are not sending data, so set iov to 0.
    */

   iov[0].iov_base   = (char *)0;
   iov[0].iov_len    = 0;

   msg.msg_iov    = iov;
   msg.msg_iovlen = 1;

   /*
    *  We are already connected, so we set the address
    *  to 0.  If we were using a connectionless transport
    *  provider, we would specify the address here.
    */

   msg.msg_name    = (caddr_t)0;
   msg.msg_namelen = 0;

   /*
    *  Fill the access rights with the file descriptors.
    */

   msg.msg_accrights    = (caddr_t)fd_array;
   msg.msg_accrightslen = sizeof(fd_array);

   result = sendmsg(sfd, &msg, 0);

   close(fd_array[0]);
   close(fd_array[1]);
   close(sfd);
   return(result);
}
